#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int main()
{
    long long n, m;
    cin >> n >> m;
    vector<long long> a[n];
    long long used[n];
    long long dist1[n];
    for (int i = 1; i < n; i++)
    {
        used[i] = 0;
        dist1[i] = 1e9;
        long long x;
        cin >> x;
        x--;
        a[i].push_back(x);
        a[x].push_back(i);
    }
    queue<long long> q;
    q.push(0);
    dist1[0] = 0;
    used[0] = 1;
    while(!q.empty())
    {
        long long cur = q.front();
        q.pop();
        for (int i = 0; i < a[cur].size(); i++)
        {
            if (used[a[cur][i]] == 0)
            {
                used[a[cur][i]] = 1;
                dist1[a[cur][i]] = dist1[cur] + 1;
                q.push(a[cur][i]);
            }
        }
    }
    long long v = 0;
    for (int i = 0; i < n; i++)
    {
        if (dist1[i] > dist1[v])
        {
            v = i;
        }
    }
    long long m1 = dist1[v];
    long long dist2[n];
    for (int i = 0; i < n; i++)
    {
        used[i] = 0;
        dist2[i] = 1e9;
    }
    q.push(v);
    dist2[v] = 0;
    used[v] = 1;
    while(!q.empty())
    {
        long long cur = q.front();
        q.pop();
        for (int i = 0; i < a[cur].size(); i++)
        {
            if (used[a[cur][i]] == 0)
            {
                used[a[cur][i]] = 1;
                dist2[a[cur][i]] = dist2[cur] + 1;
                q.push(a[cur][i]);
            }
        }
    }
    long long u = 0;
    for (int i = 0; i < n; i++)
        if (dist2[u] < dist2[i])
            u = i;
    long long m2 = dist2[u];
    if (m == 1)
        cout << m2 + 1;
    else
    {
        cout << m2 + 1 + 2 * (m1 + 1) * (m - 1);
    }
    return 0;
}

