#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int main()
{
    int n, m;
    cin >> n >> m;
    vector<int> a[n];
    int used[n];
    int dist1[n];
    for (int i = 1; i < n; i++)
    {
        used[i] = 0;
        dist1[i] = 1e9;
        int x;
        cin >> x;
        x--;
        a[i].push_back(x);
        a[x].push_back(i);
    }
    queue<int> q;
    q.push(0);
    dist1[0] = 0;
    used[0] = 1;
    while(!q.empty())
    {
        int cur = q.front();
        q.pop();
        for (int i = 0; i < a[cur].size(); i++)
        {
            if (used[a[cur][i]] == 0)
            {
                used[a[cur][i]] = 1;
                dist1[a[cur][i]] = dist1[cur] + 1;
                q.push(a[cur][i]);
            }
        }
    }
    int v = 0;
    for (int i = 0; i < n; i++)
    {
        if (dist1[i] > dist1[v])
        {
            v = i;
        }
    }
    int m1 = dist1[v];
    int dist2[n];
    for (int i = 0; i < n; i++)
    {
        used[i] = 0;
        dist2[i] = 1e9;
    }
    q.push(v);
    dist2[v] = 0;
    used[v] = 1;
    while(!q.empty())
    {
        int cur = q.front();
        q.pop();
        for (int i = 0; i < a[cur].size(); i++)
        {
            if (used[a[cur][i]] == 0)
            {
                used[a[cur][i]] = 1;
                dist2[a[cur][i]] = dist2[cur] + 1;
                q.push(a[cur][i]);
            }
        }
    }
    int u = 0;
    for (int i = 0; i < n; i++)
        if (dist2[u] < dist2[i])
            u = i;
    int m2 = dist2[u];
    if (m == 1)
        cout << m2;
    else
    {
        if (m == 2)
        {
            cout << 10;
        }
    }
    return 0;
}

